about summary refs log tree commit homepage
diff options
context:
space:
mode:
authorEric Wong <e@80x24.org>2023-07-03 00:43:05 +0000
committerEric Wong <e@80x24.org>2023-07-03 02:06:52 +0000
commit02d3d1856fb9d9d41cf1711b9ad877b520a721e6 (patch)
treefac0a033e61b682c16f5204b0b3baea8af6e28b5
parent56b5f6bfa937f1b8f274bf65aa9c71eaae7a7bfc (diff)
downloaddtas-02d3d1856fb9d9d41cf1711b9ad877b520a721e6.tar.gz
This generates a dtas-splitfx-compatible YAML snippet based
on a sorted list of audio tracks:

  dtas-2splitfx 1.flac 2.flac ... >tracks.yml
-rw-r--r--GNUmakefile2
-rwxr-xr-xscript/dtas-2splitfx44
2 files changed, 45 insertions, 1 deletions
diff --git a/GNUmakefile b/GNUmakefile
index 084a2d8..9019b31 100644
--- a/GNUmakefile
+++ b/GNUmakefile
@@ -82,7 +82,7 @@ bindir = $(prefix)/bin
 symlink-install :
         mkdir -p $(bindir)
         dtas=$(CURDIR)/dtas.sh && cd $(bindir) && \
-        for x in $(CURDIR)/bin/*; do \
+        for x in $(CURDIR)/bin/* $(CURDIR)/script/*; do \
                 ln -sf "$$dtas" $$(basename "$$x"); \
         done
 
diff --git a/script/dtas-2splitfx b/script/dtas-2splitfx
new file mode 100755
index 0000000..afa761d
--- /dev/null
+++ b/script/dtas-2splitfx
@@ -0,0 +1,44 @@
+#!/usr/bin/perl -w
+# Copyright (C) all contributors <dtas-all@nongnu.org>
+# License: GPL-3.0+ <https://www.gnu.org/licenses/gpl-3.0.txt>
+# parse soxi output and generates a dtas-splitfx-compatible YAML snippet
+# usage: dtas-2splitfx 1.flac 2.flac ... >tracks.yml
+use v5.12;
+use POSIX qw(strftime);
+open my $fh, '-|', 'soxi', @ARGV or die $!;
+my $title = '';
+my $off = 0;
+my $sec = 0;
+
+my $flush = sub {
+        my ($start) = @_;
+        my $frac = $start =~ s/\.([0-9]+)\z// ? $1 : 0;
+        $start = strftime('%H:%M:%S', gmtime($start));
+        $start .= ".$frac" if $frac;
+        $start;
+};
+
+while (<$fh>) {
+        if (/^Duration\s*:\s*([0-9:\.]+)/) {
+                my $t = $1;
+                $sec = $t =~ s/\.([0-9]+)\z// ? "0.$1" : 0;
+                my @t = split(/:/, $t); # HH:MM:SS
+                my $mult = 1;
+                while (defined(my $part = pop @t)) {
+                        $sec += $part * $mult;
+                        $mult *= 60;
+                }
+        } elsif (s/^title=//i) {
+                chomp;
+                $title = $_;
+                $title =~ tr!"!'!;
+        } elsif (/^\s*\z/s && $sec) {
+                my $start = $flush->($off);
+                say qq(- t $start "), , $title, '"';
+                $off += $sec;
+                $sec = 0;
+                $title = '';
+        }
+}
+close $fh or die "soxi failed: \$?=$?";
+say qq(- stop ), $flush->($off);